function eH = plotEllipse(x,P,nSigma)

% Author: HSO
% Date: 2011-05 
% Brief: function to retung the line points of ellipse 
% Inputs: state x, covariance P, sigma values
% Output: lines cordinates points

eH =[];
P = P(1:2,1:2); % only interested in the x and y parts of covariance
x = x(1:2); % only x and y

if(~any(diag(P)==0))
    [V,D] = eig(P); % get eigenvalues
    y = nSigma*[cos(0:0.1:2*pi); sin(0:0.1:2*pi)]; % create array vector
    el = V*sqrtm(D)*y;
    el = [el el(:,1)] + repmat(x,1,size(el,2)+1);
    eH = line(el(1,:),el(2,:));
end;
    
